function Z=Quantization_forward(I, QP, inter_intra);

% inter_intra:
%         0 -> inter
%         1 -> intra

if ( (QP > 51) || (QP < 0) )
    fprintf(1,'\n QP deber ser 0 <= QP(%d)<= 51 .\n',QP);
    return;
end

[M N]=size(I);
if ( (M ~= 4) || (N ~= 4) )
    fprintf(1,'\n DIM deben ser 4x4 (%d x %d).\n',M, N);
    return;
end

if ( ~( (inter_intra == 1) || (inter_intra == 0) ) )
    fprintf(1,'\n inter_intra=0 para inter o =1 para intra (%d).\n',inter_intra);
    return;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Parametros iniciales
qbits=15+floor(QP/6);

if ( inter_intra == 0)
    f=round( (2^qbits)/3); % intra
else
    f=round( (2^qbits)/6); %inter
end

switch rem(QP,6)
    case 0
        A=13107;
        B=5243;
        C=8066;
    case 1
        A=11916;
        B=4660;
        C=7490;
    case 2
        A=10082;
        B=4194;
        C=6554;
    case 3
        A=9362;
        B=3647;
        C=5825;
    case 4
        A=8192;
        B=3355;
        C=5243;
    case 5
        A=7282;
        B=2893;
        C=4559;
end

% Matriz de coeficientes
M=ones(4,4)*C;

M(1,1)=A;
M(3,1)=A;
M(3,3)=A;
M(1,3)=A;

M(2,2)=B;
M(2,4)=B;
M(4,2)=B;
M(4,4)=B;

% Proceso cuantificacion
for fil=1:4
    for col=1:4
        Z(fil,col)=floor( (abs( I(fil,col) )*M(fil,col)+f)/2^qbits);
        Z(fil,col)=sign(I(fil,col))*Z(fil,col);
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                              %%
%% COMPRESION DE VIDEO                                          %%
%% Grado en Ingeniera de Tecnologas de Telecomunicacin       %%
%% Gustavo A. Ruiz Robredo                                      %%
%% ruizrg@unican.es                                             %%
%%                                                              %%
%% uu   uu  cccccc   UNIVERSIDAD DE CANTABRIA                   %%
%% uu   uu  cccccc   Dpto. INGENIERIA INFORMATICA Y ELECTRONICA %%
%% uu   uu  cc       FACULTAD DE CIENCIAS                       %%
%%  uuuuu   cccccc   Avda. Los Castros s/n                      %%
%%   uuu    cccccc   39005-SANTANDER (SPAIN)                    %%
%%                                                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


