function W=Quantization_inverse(I, QP);

if ( (QP > 51) || (QP < 0) )
    fprintf(1,'\n QP deber ser 0 <= QP(%d)<= 51 .\n',QP);
    return;
end

[M N]=size(I);
if ( (M ~= 4) || (N ~= 4) )
    fprintf(1,'\n DIM deben ser 4x4 (%d x %d).\n',M, N);
    return;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Parametros iniciales
switch rem(QP,6)
    case 0
        A=10;
        B=16;
        C=13;
    case 1
        A=11;
        B=18;
        C=14;
    case 2
        A=13;
        B=20;
        C=16;
    case 3
        A=14;
        B=23;
        C=18;
    case 4
        A=16;
        B=25;
        C=20;
    case 5
        A=18;
        B=29;
        C=23;
end

% Matriz de coeficientes
M=ones(4,4)*C;

M(1,1)=A;
M(3,1)=A;
M(3,3)=A;
M(1,3)=A;

M(2,2)=B;
M(2,4)=B;
M(4,2)=B;
M(4,4)=B;

% Proceso cuantificacion
for fil=1:4
    for col=1:4
        W(fil,col)=floor( I(fil,col)*M(fil,col)*(2^floor(QP/6)) );
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                              %%
%% COMPRESION DE VIDEO                                          %%
%% Grado en Ingeniera de Tecnologas de Telecomunicacin       %%
%% Gustavo A. Ruiz Robredo                                      %%
%% ruizrg@unican.es                                             %%
%%                                                              %%
%% uu   uu  cccccc   UNIVERSIDAD DE CANTABRIA                   %%
%% uu   uu  cccccc   Dpto. INGENIERIA INFORMATICA Y ELECTRONICA %%
%% uu   uu  cc       FACULTAD DE CIENCIAS                       %%
%%  uuuuu   cccccc   Avda. Los Castros s/n                      %%
%%   uuu    cccccc   39005-SANTANDER (SPAIN)                    %%
%%                                                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%