function cost = costFuncSAD(currentBlk, refBlk)
%
% Calcula el MAD de dos imagenes
% Entradas:
%        currentBlk: imagen actual
%        refBlk: imagen de referencia
%
% Ambas imagenes deben tener la misma dimension
%
% Salidas:
%    cost-> valor del coste SAD
%

[Mblk Nblk]=size(currentBlk);
[Mref Nref]=size(refBlk);

if ( (Mblk ~= Mref) || (Nblk ~= Nref) )
    fprintf(1,'\n DIM current block (%d x %d) no coincide con el de ref block (%d x %d).\n',Mblk, Nblk, Mref, Nref);
    return;
end

cost =sum(sum( abs(( int32(currentBlk ) - int32( refBlk) ) )));




